//
//  OTPSOCK
//
//	Copyright (C) 1996,1997 NEC Corporation
//	All rights reserved.
//  Authos(s): Mizukoshi, Yasuhiro <mizukosi@ccs.mt.nec.co.jp>
//

//	    $Archive: /sotools/otpsock/otpsock.h $
//			$Revision: 3 $
//			$Date: 97/05/15 11:51a $

#include	<nspapi.h>
#include	<wtypes.h>

#ifdef WIN32
#define EXPORT
#else
#define EXPORT _export
#endif

#ifdef WIN32
#define MALLOC	malloc
#define FREE	free
#define MEMCPY	memcpy
#else
#define MALLOC	_fmalloc
#define FREE	_ffree
#define MEMCPY	_fmemcpy
#endif

#ifdef _DEBUG
#define	x_OutputDebugString(x)	OutputDebugString(x)
#else
#define	x_OutputDebugString(x)
#endif


#define	ORIGINAL_WSOCK32	"ws_otp.dll"


#define PASS_PHRASE_MIN_LEN	8
#define PASS_PHRASE_MAX_LEN	256
#define	SEED_MAX_LEN		1024
#define	ONETIME_KEY_MAX_LEN	256

#define		SEQSEED_POS		" %d %s"

#define		FUNCNAME_MD2	"md2"
#define		FUNCNAME_MD4	"md4"
#define		FUNCNAME_MD5	"md5"
#define		FUNCNAME_SHA1	"sha1"

#define		MD2				0
#define		MD4				1
#define		MD5				2
#define		SHA1			3

#define		FTP_MODE		1
#define		TELNET_MODE		2

extern char *OTP_btoe(char *, char *);

extern int  _otp_MD4_keycrunch(char *, char *, char *);
extern void _otp_MD4_iterate(char *);
extern int  _otp_MD5_keycrunch(char *, char *, char *);
extern void _otp_MD5_iterate(char *);
extern int  _otp_SHA1_keycrunch(char *result, char *seed, char *passwd);
extern void _otp_SHA1_iterate(char *x);



int LoadWinsock();
int FreeWinsock();

struct FunctionTable {
	HANDLE		hWinsock;

	SOCKET(PASCAL FAR * accept) (SOCKET s, struct sockaddr FAR * addr, int FAR * addrlen);
	int (PASCAL FAR * bind) (SOCKET s, const struct sockaddr FAR * addr, int namelen);
	int (PASCAL FAR * closesocket) (SOCKET s);
	int (PASCAL FAR * connect) (SOCKET s, const struct sockaddr FAR * name, int namelen);
	int (PASCAL FAR * getsockname) (SOCKET s, struct sockaddr FAR * name, int FAR * namelen);
	u_short(PASCAL FAR * htons) (u_short hostshort);
	u_long(PASCAL FAR * htonl) (u_long hostlong);
	unsigned long (PASCAL FAR * inet_addr) (const char FAR * cp);
	int (PASCAL FAR * listen) (SOCKET s, int backlog);
	u_short(PASCAL FAR * ntohs) (u_short netshort);
	int (PASCAL FAR * recv) (SOCKET s, char FAR * buf, int len, int flags);
	int (PASCAL FAR * send) (SOCKET s, const char FAR * buf, int len, int flags);
	SOCKET(PASCAL FAR * socket) (int af, int type, int protocol);
	struct hostent FAR *(PASCAL FAR * gethostbyaddr) (const char FAR * addr, int len, int type);
	struct hostent FAR *(PASCAL FAR * gethostbyname) (const char FAR * name);
	int (PASCAL FAR * gethostname) (char FAR * name, int namelen);
	int (PASCAL FAR * WSAStartup) (WORD wVersionRequired, LPWSADATA lpWSAData);
	int (PASCAL FAR * WSACleanup) (void);
	int (PASCAL FAR * WSAGetLastError) (void);
	BOOL(PASCAL FAR * WSAIsBlocking) (void);
	int (PASCAL FAR * WSACancelBlockingCall) (void);
	int (PASCAL FAR * WSAUnhookBlockingHook) (void);
	FARPROC(PASCAL FAR * WSASetBlockingHook) (FARPROC lpBlockFunc);
	int (PASCAL FAR * setsockopt) (SOCKET s, int level, int optname, const char FAR * optval, int optlen);
	int (PASCAL FAR * ioctlsocket) (SOCKET s, long cmd, u_long FAR *argp);
	int (PASCAL FAR * WSACancelAsyncRequest) (HANDLE hAsyncTaskHandle);
	int (PASCAL FAR * WSAAsyncSelect) (SOCKET s, HWND hWnd, u_int wMsg, long lEvent);
	HANDLE (PASCAL FAR * WSAAsyncGetHostByName) (HWND hWnd, u_int wMsg, const char FAR * name, char FAR * buf, int buflen);
	int (PASCAL FAR * getpeername) (SOCKET s, struct sockaddr FAR *name, int FAR * namelen);

	int (PASCAL FAR * getsockopt) (SOCKET s, int level, int optname, char FAR * optval, int FAR *optlen);
	char FAR * (PASCAL FAR * inet_ntoa) (struct in_addr in);
	u_long (PASCAL FAR * ntohl) (u_long netlong);
	int (PASCAL FAR * recvfrom) (SOCKET s, char FAR * buf, int len, int flags, struct sockaddr FAR *from, int FAR * fromlen);
	int (PASCAL FAR * select) (int nfds, fd_set FAR *readfds, fd_set FAR *writefds, fd_set FAR *exceptfds, const struct timeval FAR *timeout);
	int (PASCAL FAR * sendto) (SOCKET s, const char FAR * buf, int len, int flags, const struct sockaddr FAR *to, int tolen);
	int (PASCAL FAR * shutdown) (SOCKET s, int how);
	struct servent FAR * (PASCAL FAR * getservbyport) (int port, const char FAR * proto);
	struct servent FAR * (PASCAL FAR * getservbyname) (const char FAR * name, const char FAR * proto);
	struct protoent FAR * (PASCAL FAR * getprotobynumber) (int proto);
	struct protoent FAR * (PASCAL FAR * getprotobyname) (const char FAR * name);
	void (PASCAL FAR * WSASetLastError) (int iError);
	HANDLE (PASCAL FAR * WSAAsyncGetServByName) (HWND hWnd, u_int wMsg, const char FAR * name, const char FAR * proto, char FAR * buf, int buflen);
	HANDLE (PASCAL FAR * WSAAsyncGetServByPort) (HWND hWnd, u_int wMsg, int port, const char FAR * proto, char FAR * buf, int buflen);
	HANDLE (PASCAL FAR * WSAAsyncGetProtoByName) (HWND hWnd, u_int wMsg, const char FAR * name, char FAR * buf, int buflen);
	HANDLE (PASCAL FAR * WSAAsyncGetProtoByNumber) (HWND hWnd, u_int wMsg, int number, char FAR * buf, int buflen);
	HANDLE (PASCAL FAR * WSAAsyncGetHostByAddr) (HWND hWnd, u_int wMsg, const char FAR * addr, int len, int type, char FAR * buf, int buflen);
	int (PASCAL FAR * __WSAFDIsSet) (SOCKET s, fd_set FAR *set);

	INT (PASCAL FAR * EnumProtocolsA)		(LPINT lpiProtocols, LPVOID lpProtocolBuffer, LPDWORD lpdwBufferLength);
	INT (PASCAL FAR * EnumProtocolsW)		(LPINT lpiProtocols, LPVOID lpProtocolBuffer, LPDWORD lpdwBufferLength);
	INT (PASCAL FAR * GetAddressByNameA)	(DWORD dwNameSpace, LPGUID lpServiceType, LPSTR lpServiceName, LPINT lpiProtocols, DWORD dwResolution, LPSERVICE_ASYNC_INFO lpServiceAsyncInfo, LPVOID lpCsaddrBuffer, LPDWORD lpdwBufferLength, LPSTR lpAliasBuffer, LPDWORD lpdwAliasBufferLength);
	INT (PASCAL FAR * GetAddressByNameW)	(DWORD dwNameSpace, LPGUID lpServiceType, LPWSTR lpServiceName,
										    LPINT lpiProtocols, DWORD dwResolution, LPSERVICE_ASYNC_INFO lpServiceAsyncInfo,
										    LPVOID lpCsaddrBuffer, LPDWORD lpdwBufferLength, LPWSTR lpAliasBuffer, LPDWORD lpdwAliasBufferLength);	
	INT (PASCAL FAR * GetNameByTypeA)		(LPGUID lpServiceType, LPSTR lpServiceName, DWORD dwNameLength);
	INT (PASCAL FAR * GetNameByTypeW)		(LPGUID lpServiceType, LPWSTR lpServiceName, DWORD dwNameLength);
	INT (PASCAL FAR * GetServiceA)			(DWORD dwNameSpace, LPGUID lpGuid, LPSTR lpServiceName, DWORD dwProperties, LPVOID lpBuffer,
										    LPDWORD lpdwBufferSize, LPSERVICE_ASYNC_INFO lpServiceAsyncInfo);
	INT (PASCAL FAR * GetServiceW)			(DWORD dwNameSpace, LPGUID lpGuid, LPWSTR lpServiceName, DWORD dwProperties, LPVOID lpBuffer,
										    LPDWORD lpdwBufferSize, LPSERVICE_ASYNC_INFO lpServiceAsyncInfo);
	INT (PASCAL FAR * GetTypeByNameA)		(LPSTR lpServiceName, LPGUID lpServiceType);
	INT (PASCAL FAR * GetTypeByNameW)		(LPWSTR lpServiceName, LPGUID lpServiceType);
	INT (PASCAL FAR * SetServiceA)			(DWORD dwNameSpace, DWORD dwOperation, DWORD dwFlags, LPSERVICE_INFOA lpServiceInfo,
										    LPSERVICE_ASYNC_INFO lpServiceAsyncInfo, LPDWORD lpdwStatusFlags);
	INT (PASCAL FAR * SetServiceW)			(DWORD dwNameSpace, DWORD dwOperation, DWORD dwFlags, LPSERVICE_INFOW lpServiceInfo,
										    LPSERVICE_ASYNC_INFO lpServiceAsyncInfo, LPDWORD lpdwStatusFlags);
	BOOL (PASCAL FAR * TransmitFile)		(SOCKET hSocket, HANDLE hFile, DWORD nNumberOfBytesToWrite, DWORD nNumberOfBytesPerSend,
										    LPOVERLAPPED lpOverlapped, LPTRANSMIT_FILE_BUFFERS lpTransmitBuffers, DWORD dwFlags);	
	int (PASCAL FAR * WSARecvEx)			(SOCKET s, char FAR * buf, int len, int *flags);	

	void (PASCAL FAR * WsControl)			();
	void (PASCAL FAR * closesockinfo)		();
	void (PASCAL FAR * Arecv)				();
	void (PASCAL FAR * Asend)				();
	void (PASCAL FAR * WSHEnumProtocols)	();
	void (PASCAL FAR * inet_network)		();
	void (PASCAL FAR * getnetbyname)		();
	void (PASCAL FAR * rcmd)				();
	void (PASCAL FAR * rexec)				();
	void (PASCAL FAR * rresvport)			();
	void (PASCAL FAR * sethostname)			();
	void (PASCAL FAR * dn_expand)			();
	void (PASCAL FAR * s_perror)			();
	void (PASCAL FAR * NPLoadNameSpaces)	();
};

struct LocalData {
	HANDLE	hWinsock;

	BOOL	bInCall;
};


int otpmain(SOCKET s, char FAR * buf, int len, int flags);
int SendPassMode(const struct sockaddr FAR *name, int namelen);
int CheckSeqNum();


#define	DEFAULT_OTPCALC		"DOTKEY95"
#define OTPSOCK_SUBKEY		"Software\\NEC\\otpsock"
#define	OTPCALC_VALNAME		"OTPCalcWndName"

int	InitPreferences();


#define	MAX_OTPBUF_SIZE		1024

struct OTPData {
	char	recvbuf[MAX_OTPBUF_SIZE + 1];
	int		recvbuf_pos;

	BOOL	bSendPass;
	int		mode;
	int		hash_func;
	int		seq;
	char	seed[SEED_MAX_LEN];
	char	pass[ONETIME_KEY_MAX_LEN];
	char	FuncName[128];
	int  (* KeyCrunchFunc)(char *, char *, char *);
	void (* IterateFunc)  (char *);
};

#ifdef	GLOBAL
#define	EXTERN
#else
#define	EXTERN extern
#endif

EXTERN	HANDLE					ghModule;
EXTERN	DWORD					TlsIndex;
EXTERN	struct FunctionTable	gft;

EXTERN	struct OTPData			gOTPData;

EXTERN	COPYDATASTRUCT			gCDS;
EXTERN	char					gtbuf[MAX_OTPBUF_SIZE + 1];

EXTERN	char					gOTPCalcWndName[128];

#undef	EXTERN
